
// flagdelay
//

#include <assert.h>
#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <string.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <signal.h>
#include <errno.h>
#include <sys/ioctl.h>
#include <linux/if.h>
#include <linux/if_tun.h>

#include "flags.h"

unsigned char Ip_frame_1[IP_FRAME_MAX_SIZE+1];
unsigned char Ip_frame_2[IP_FRAME_MAX_SIZE+1];

static int Done=0; // end prog and/or signal number
void tschues(int goodbyval){
    Done=goodbyval;
}

int main(int argc, char **argv){
    int fd1;
    int fd2;
    fd_set rfds;
    fd_set efds;
    struct timeval tv;
    int i_1;
    int i_2;
    int n;
    char *dev_new_name_1;
    char *dev_new_name_2;
    if (argc!=4){
        fprintf(stderr,"usage:\n%s /dev/net/tun\\"
                       "local_ipv4_addr1 local_ipv4_addr2\n",argv[0]);
        exit(1);
    }
    fd1=tun_alloc(argv[1],&dev_new_name_1);
    if (fd1<0){
        fprintf(stderr,"\nfatal: open(%s,O_RDWR) failed\n",argv[1]);
        exit(1);
    }
    fd2=tun_alloc(argv[1],&dev_new_name_2);
    if (fd2<0){
        fprintf(stderr,"\nfatal: open(%s,O_RDWR) failed\n",argv[1]);
        exit(1);
    }
    ioctl(fd1,TUNSETNOCSUM,IFF_TUN); // stuff to discuss
    ioctl(fd2,TUNSETNOCSUM,IFF_TUN); // stuff to discuss
    //
    // now assign the ipv4 address
    snprintf(Ip_frame_1,sizeof(Ip_frame_1),"ifconfig %s inet %s mtu 576",dev_new_name_1,argv[2]);
    fprintf(stdout,"\nnow executing:\n%s",Ip_frame_1);
    system(Ip_frame_1);
    snprintf(Ip_frame_2,sizeof(Ip_frame_2),"ifconfig %s inet %s mtu 576",dev_new_name_2,argv[3]);
    fprintf(stdout,"\nnow executing:\n%s",Ip_frame_2);
    system(Ip_frame_2);
    fprintf(stdout,"\nifconfig done\n");
    //
    //
    snprintf(Ip_frame_1,sizeof(Ip_frame_1),
        "route add -net 1.2.3.1 netmask 255.255.255.255  dev %s",/*argv[3],*/dev_new_name_1);
    fprintf(stdout,"\nnow executing:\n%s",Ip_frame_1);
    system(Ip_frame_1);
    snprintf(Ip_frame_2,sizeof(Ip_frame_2),
        "route add -net 1.2.3.2 netmask 255.255.255.255  dev %s",/*argv[4],*/dev_new_name_2);
    fprintf(stdout,"\nnow executing:\n%s",Ip_frame_2);
    system(Ip_frame_2);
    fprintf(stdout,"\nroute done\n");
    n=max(2,fd1);
    n=max(n,fd2);
    n++;
    for (;!Done;){
        FD_ZERO(&rfds);
        FD_SET(fd1,&rfds);
        FD_SET(fd2,&rfds);
        FD_ZERO(&efds);
        FD_SET(fd1,&rfds);
        FD_SET(fd2,&efds);
        tv.tv_sec=0;
        tv.tv_usec=10000;
        select(n,&rfds,NULL,&efds,&tv);
        if (FD_ISSET(fd1,&rfds)){
            i_1=read(fd1,Ip_frame_1,sizeof(Ip_frame_1));
            if (i_1>0){
                i_1=write(fd2,Ip_frame_2,i_1);
                if (i_1<0)
                    fprintf(stderr,"\nerror frame is not echo, reason=%3d",i_1);
            }
        }
        if (FD_ISSET(fd2,&rfds)){
            i_2=read(fd2,Ip_frame_2,sizeof(Ip_frame_2));
            if (i_2>0){
                i_2=write(fd1,Ip_frame_1,i_2);
                if (i_2<0)
                    fprintf(stderr,"\nerror frame is not echo, reason=%3d",i_2);
            }
        }
    }
    return Done;
}


