

///////////////////////////////////////////////////////////////////////////
// a bit of nipple addressing

#define  u8_t unsigned char
#define u16_t unsigned short
#define u32_t unsigned int

#define swap16(a) ((((a) & 0xff)<<8) | ((a>>8)&0xff))

// offset is always in octets

// address
#define  a8(base,offset)   ( ( u8_t*) (((u8_t*)(base))+(offset)) )
#define a16(base,offset)   ( (u16_t*) (((u8_t*)(base))+(offset)) )
#define a32(base,offset)   ( (u32_t*) (((u8_t*)(base))+(offset)) )

// nipples  
#define get_hi_nipple(base,offset)  ( ( (*a8((base),(offset)))>>4 ) &0xf)
#define get_lo_nipple(base,offset)  (   (*a8((base),(offset)))      &0xf)

#define set_hi_nipple(base,offset,val) \
    do { *a8((base),(offset))= get_lo_nipple((base),(offset))     | (((val)&0xf)<<4); } while (0)

#define set_lo_nipple(base,offset,val) \
    do { *a8((base),(offset))=(get_hi_nipple((base),(offset))<<4) |  ((val)&0xf)    ; } while (0)

/////////////////////////////////////////////////////////////////////////////
// now what we use for echo

// ip header
#define A_IP_HEADER_OCTET_MIN_LENGTH (5*4)

#define a_ip_get_version(cp)             get_hi_nipple((cp),0)
#define a_ip_get_header_length(cp)       get_lo_nipple((cp),0)    
#define a_ip_set_version(cp,v)           set_hi_nipple((cp),0,(v))
#define a_ip_set_header_length(cp,len)   set_lo_nipple((cp),0,(len))    

#define A_IP_OFFSET_TOS             1 
#define A_IP_OFFSET_LENGTH          2 
#define A_IP_OFFSET_IDENTIFICATION  4 
#define A_IP_OFFSET_TTL             8 
#define A_IP_OFFSET_PROTOCOL        9 
#define A_IP_OFFSET_CHKSUM         10
#define A_IP_OFFSET_SRC_ADDR       12
#define A_IP_OFFSET_DEST_ADDR      16

// icmp stuff
#define A_ICMP_HEADER_ECHO_OCTET_LEN    8
#define A_ICMP_OFFSET_TYPE              0
#define A_ICMP_OFFSET_CODE              1
#define A_ICMP_OFFSET_CHKSUM            2

//////////////////////////////////////////////////////////////////////////////////
// defines for our block encoding
#define IP_FRAME_MAX_SIZE 4096

#define FL_BLOCKS_PER_IP_FRAME_MAX 256 /* protocol limit */
#define FL_BLOCK_PAYLOAD_MAX_SIZE (2*IP_FRAME_MAX_SIZE) /* we allow everything in 1 single giant block */

#define FL_BLOCK_TRAIER_MAX_SIZE 9 /* 32_bit_crc + end_of_block */

// block offsets
#define FL_START_OFFSET         0
#define FL_BLOCK_TYPE_OFFSET    1
#define FL_PROT_OFFSET          2
#define FL_CHECKSUM_TYPE_OFFSET 3
#define FL_BLOCKNUM_OFFSET      4
#define FL_BLOCKNUM_OFFSET_HIGH 4
#define FL_BLOCKNUM_OFFSET_LOW  5
#define FL_DATA_OFFSET          6

#define FL_BLOCK_HEADER_SIZE    6 /* including start_of_block */

#define FL_BLOCK_MAX_SIZE (FL_BLOCK_HEADER_SIZE+FL_BLOCK_PAYLOAD_MAX_SIZE+FL_BLOCK_TRAIER_MAX_SIZE)

// block type
#define FL_DATA 0
#define FL_ACK  1
#define FL_NACK 2
// protocol
#define FL_PROTOCOL_NONE    0
#define FL_PROTOCOL_IP4     0
// checksum
#define FL_CHECKSUM_NONE    0
#define FL_CHECKSUM_CRC16   1

#define FL_BL_START         'q'
#define FL_BL_FIN           'r'
#define FL_IP_FRAME_FIN     'z'

///////////////////////////////////////////////////////////////////////////
// utility stuff
#define nipple2char(n) ('a'+((n)&0xf))

#ifndef max
#define max(a,b) (((a)>(b))?(a):(b))
#endif

#ifndef min
#define min(a,b) (((a)<(b))?(a):(b))
#endif

////////////////////////////////////////////////////////////////////////////
int tun_alloc(char *dev,char **new_name);
int print_ip_frame(char *text,void *frame,int len);
unsigned short ip4_chk_sum(void *base, int len);

int nipple_hi(int i);
int nipple_lo(int i);
int nipple_get(void *base,int index);

int ipv4_2_fl(void *ip_frame, int ip_frame_size,int flags_per_junk,
	      unsigned char a[FL_BLOCKS_PER_IP_FRAME_MAX][FL_BLOCK_MAX_SIZE]);
int fl_2_ipv4(void *ip_frame, int blocks,
	      unsigned char a[FL_BLOCKS_PER_IP_FRAME_MAX][FL_BLOCK_MAX_SIZE]);
int fl_get_frame_len(unsigned char *blk);

int nipple_hi(int i);
int nipple_lo(int i);
int get_nipple(void *base,int index);

